.nolist
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 1000000	; 1000000 would be a typical value

CcallP PROTO C:DWORD, :VARARG
.data
Src	db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos.", 0

.data?
Dest	db 100 dup(?)

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level
	REPEAT 2
		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke CcallP, 3, ecx, edx, eax
		counter_end
		print str$(eax), 9, "cycles for CcallP  3", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			invoke CcallP, 6, ecx, edx, eax, 4, 5, 6
		counter_end
		print str$(eax), 9, "cycles for CcallP  6", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push eax
			push edx
			push ecx
			push 3
			call VarArgP
		counter_end
		print str$(eax), 9, "cycles for VarArgP 3", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push 6
			push 5
			push 4
			push eax
			push edx
			push ecx
			push 6
			call VarArgP
		counter_end
		print str$(eax), 9, "cycles for VarArgP 6", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push eax
			push edx
			push ecx
			push 33
			call FixArgP3
		counter_end
		print str$(eax), 9, "cycles for FixArgP 3", 13, 10

		invoke Sleep, 100
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
			push 6
			push 5
			push 4
			push eax
			push edx
			push ecx
			push 66
			call FixArgP6
		counter_end
		print str$(eax), 9, "cycles for FixArgP 6", 13, 10, 10

	ENDM

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

VarArgP proc ctarg:SDWORD, args
LOCAL dummy1:DWORD
  mov dummy1, 12345
  mov edx, ctarg	; argctD
  leave			; restore stack
  lea esp, [esp+4*edx+8]	; adjust stack for argcount
  neg edx
	if 1
		jmp dword ptr [esp+4*edx-8]	; ret equivalent
	else
		push dword ptr [esp+4*edx-8]	; 2 cycles slower
		retn
	endif
VarArgP endp

FixArgP3 proc ctarg:SDWORD, arg1, arg2, arg3
LOCAL dummy1:DWORD
  mov dummy1, 12345
  ret
FixArgP3 endp

FixArgP6 proc ctarg:SDWORD, arg1, arg2, arg3, arg4, arg5, arg6
LOCAL dummy1:DWORD
  mov dummy1, 12345
  ret
FixArgP6 endp

CcallP proc C ctarg:DWORD, args:VARARG
LOCAL dummy1:DWORD
  mov dummy1, 12345
  mov edx, ctarg	; argctD
  ret
CcallP endp


ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]